SystemOrganization addCategory: #'DAO-TP-Changes-Server'!

Object subclass: #MutexParaGemstone
	instanceVariableNames: 'owner semaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!MutexParaGemstone methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/7/2013 16:14'!
critical: aBlock
	"Evaluate aBlock protected by the receiver."
	| activeProcess |
	activeProcess := Processor activeProcess.
	activeProcess == owner ifTrue:[^aBlock value].
	^semaphore critical:[
		owner := activeProcess.
		aBlock ensure:[owner := nil]]. ! !

!MutexParaGemstone methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/7/2013 16:14'!
initialize
	super initialize.
	semaphore := Semaphore forMutualExclusion.! !

Object subclass: #SistemaDeCambiosInterfazTCP_Server
	instanceVariableNames: 'connectionSocket isRunning isRunningLock listenPort sistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!SistemaDeCambiosInterfazTCP_Server class methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 02:12'!
listenOn: aPort for: aSistemaDeCambios
	aPort isInteger
		ifTrue: [ 
			^self new initializeWith: aPort and: aSistemaDeCambios.
		]
		ifFalse: [ 
			Exception new signal: 'Puerto invlido'.
		]
 
	! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 01:55'!
decodificar: aByteString 
^
	(NeoJSONReader on: aByteString readStream)
		for: DateAndTime customDo: [ :mapping |
			mapping decoder: [ :string | DateAndTime fromString: string ].
			mapping encoder: [ :dateAndTime | dateAndTime printString ]
		];
		next.
! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 01:57'!
handle: aByteString 
| dic aMessage anAuthor aClock intEntrada |
	dic := self decodificar: aByteString.
	(dic keys asSet = #(m a c) asSet) ifTrue:[
		aMessage := Message selector: ((dic at: 'm') at: 'selector') asSymbol arguments: ((dic at: 'm') at: 'args').
		aMessage lookupClass: self class.
		anAuthor := dic at: 'a'.
		aClock := dic at: 'c'.
		intEntrada := InterfazDeEntradaDelSistemaDeCambios remotoWith: sistemaDeCambios andThisAuthor: anAuthor andThisClock: aClock.
		aMessage sendTo: intEntrada.
		"intEntrada sendMessage: aMessage."
	]
	ifFalse:[
		Exception new signal: 'Comando Invlido'.
	]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/7/2013 16:12'!
initialize
	super initialize.
	isRunningLock := MutexParaGemstone new.
	self isRunning: false.
	listenPort := 9999.
	sistemaDeCambios := SistemaDeCambios new.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 00:44'!
initializeWith: aPort and: aSistemaDeCambios 
	listenPort := aPort.
	sistemaDeCambios := aSistemaDeCambios.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:36'!
interactOnConnection 
	| interactionSocket |
	interactionSocket := connectionSocket waitForAcceptFor: 1 ifTimedOut: [^self].
	[self interactUsing: interactionSocket] fork.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/3/2013 23:24'!
interactUsing: interactionSocket
| interactionStream|
[
	interactionStream :=  SocketStream on: interactionSocket.
	self handle: interactionStream nextLine crLog.
	interactionStream sendCommand: 'Recibido Ok ;-P'.
] ensure: [ interactionSocket close ]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:22'!
isRunning
	^isRunningLock critical: [ isRunning ].! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:23'!
isRunning: aBoolean
	^isRunningLock critical: [ isRunning := aBoolean ].! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:26'!
serve
	[ [ self isRunning ]
		whileTrue: [ self interactOnConnection ] ]
		ensure: [ connectionSocket closeAndDestroy ]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:29'!
start
	isRunningLock critical: [
		self isRunning ifTrue: [ ^ self ].
		self isRunning: true].
	connectionSocket := Socket newTCP.
	connectionSocket listenOn: listenPort backlogSize: 10.
	[ self serve ] fork! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:25'!
stop
	isRunning := false.! !

TestCase subclass: #SDCITCPS_Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!SDCITCPS_Test methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 00:54'!
mandameUnSms: aPort
	| ss |
	ss := SocketStream openConnectionToHostNamed: '127.0.0.1' port: aPort.
	[
		ss sendCommand: '{"m":{"args":["Nombre-De-Categoria"],"selector":"classCategoryCreated:"},"a":"Seba","c":"2013-12-04T00:51:54.334-03:00"}'.
	] ensure: [ ss close ]
	! !

!SDCITCPS_Test methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 02:02'!
test01
| unSistemaDeCambios unServer aPort |
	[
		aPort := 9901.
		unSistemaDeCambios := SistemaDeCambios new.
		self assert:(unSistemaDeCambios todosLosCambios isEmpty).
		unServer := SistemaDeCambiosInterfazTCP_Server listenOn: aPort for: unSistemaDeCambios.
		unServer start.
		self mandameUnSms: aPort.
		(Delay forSeconds: 5) wait.
		self assert: (unSistemaDeCambios todosLosCambios size > 0).		
	] ensure: [ unServer stop ]! !
